/***************************************************************************

Copyright (C) 2006 BBC Worldwide Limited. All Rights Reserved.

****************************************************************************/ 

/************************* ASSET OBJECT *************************/
function Asset(id, label, src, url, downloadUrl, shotDescription, duration)
{
	var img = new Image();
	img.src = src;
	this.posterFrame = img;
	this.assetId = id;
	this.videoUrl = url;
	this.downloadUrl = downloadUrl;
	this. shotDescription = shotDescription;
	this.duration = duration;
	this.label = label;
}

/************************* Global Variables *************************/
var g_selectedIndex = -1;
var g_hoverIndex = -1;
var g_loaded = false;
var g_request;
var g_assetArray;
var g_currentPage;
var g_pageCount;
var g_assetCount;
var g_url = "http://www.bbcmotiongallery.com/PublicWS/TmgSearchService.asmx/Search?searchTerm=";
var g_searchDetailsUrl = "http://www.bbcmotiongallery.com/Customer/SearchDetails.aspx?itemId=";
var CLIPS_PER_PAGE = 6;
var DEBUG = false;

/************************* setup *************************/
function setup()
{
	setupScrollBar();
	initSearchState();
}

/************************* initSearchState *************************/
function initSearchState()
{
	clearAssets();
	clearScreen();
	g_pageCount = 0;
	g_assetCount = 0;
	g_currentPage = 1;
	g_loaded = false;
}

/************************* setupScrollBar *************************/ 
function setupScrollBar()
{
	gMyScrollbar = new AppleVerticalScrollbar(document.getElementById("myScrollbar"));
     	gMyScrollArea = new AppleScrollArea(document.getElementById("myScrollArea"));
     	gMyScrollArea.addScrollbar(gMyScrollbar);
}

/************************* disableControl *************************/
function disableControl(controlName, state)
{
	var control = document.getElementById(controlName)
	if(control)
	{
		control.disabled = state;
	}
}

/************************* showControl *************************/
function showControl(controlName, show)
{
	var control = document.getElementById(controlName);
	if(control)
	{
		
		if(show)
		{
			control.className = "show";
		}
		else
		{
			control.className = "hide";
		}
	}
}

/************************* search *************************/
function search()
{
	initSearchState();
	var term = document.searchForm.searchTerm.value;
	if(term.length > 0)
	{
		var searchUrl = g_url + term;
		loadXMLDoc(searchUrl);
	}
}

/************************* loadXMLDoc *************************/
function loadXMLDoc(url)
{
	try
	{
		g_request = new XMLHttpRequest();
	}
	catch(e)
	{
		g_request = false;
	}

	if(g_request)
	{
		g_request.onload = function(e) { processRequestLoad(e, g_request); }
		g_request.onreadystatechange = processRequestChange;
		g_request.overrideMimeType("text/xml");
		g_request.open("GET", url);
		g_request.send(null);
	}
}


/************************* processRequestLoad *************************/
function processRequestLoad(e, request)
{
	if(request.responseXML)
	{
		initAssets(request.responseXML);
		setLoadedState(true);
	}
	else
	{
		displayMessage("There was a problem retrieving the XML data.");
	}
}

/************************* processRequestChange *************************/
function processRequestChange()
{

	var REQUESTSTATE_UNINITIALIZED = 0;
	var REQUESTSTATE_LOADING = 1;
	var REQUESTSTATE_LOADED = 2;
	var REQUESTSTATE_DYNAMIC = 3;
	var REQUESTSTATE_COMPLETE = 4;

	switch ( g_request.readyState ) 
	{
		case REQUESTSTATE_UNINITIALIZED: 
			displayMessage("Retrieving clips.  Please wait...");
			break;
		case REQUESTSTATE_LOADING:
			displayMessage("Retrieving clips.  Please wait...");
			break;
		case REQUESTSTATE_LOADED:
			displayMessage("Loading clips.  Please wait...");
			break;
		case REQUESTSTATE_DYNAMIC:
			displayMessage("Loading clips.  Please wait...");
			break;
		case REQUESTSTATE_COMPLETE:
			displayMessage("Loading complete.");
			break;
	}

}

/************************* initAssets *************************/
function initAssets(tree)
{
	nodes = tree.documentElement.getElementsByTagName("Clip");
	g_assetCount = nodes.length;

	// If results are returned, enable the navigation buttons
	if(g_assetCount > 0)
	{
		displayTotalCount();
		showControl("btnPrev", true);
		showControl("btnNext", true);
		displayMessage("Clips loaded. Roll your mouse over a clip to see the shot description.");
	}
	else
	{
		displayMessage("No clips found matching your query.<br/>Please try again.");
	}
	
	if(tree.hasChildNodes())
	{
		g_assetArray = new Array(nodes.length);
		
		for(var i = 0; i < nodes.length; i++)
		{
			var assetId = nodes[i].getElementsByTagName('Id')[0].firstChild.nodeValue;
			var label = nodes[i].getElementsByTagName('Label')[0].firstChild.nodeValue;
			var imgSrc = nodes[i].getElementsByTagName('PosterFrameUrl')[0].firstChild.nodeValue;
			var videoUrl = nodes[i].getElementsByTagName('VideoUrl')[0].firstChild. nodeValue;
			var downloadUrl = nodes[i].getElementsByTagName('DownloadUrl')[0].firstChild. nodeValue;
			var shotDescription = nodes[i].getElementsByTagName('ShotDescription')[0].firstChild. nodeValue;
			var duration = nodes[i].getElementsByTagName('Duration')[0].firstChild. nodeValue;
			var assetObj = new Asset(assetId, label, imgSrc, videoUrl, downloadUrl, shotDescription, duration);

			g_assetArray[i] = assetObj;
		}
		
		displayAssets();
	}
	else
	{
		document.write(tree.text);
	}
}

/************************* setLoadedState *************************/
function setLoadedState(loadstatus)
{
	g_loaded = loadstatus;
}

/************************* clearScreen *************************/
function clearScreen()
{
	var totalCount = document.getElementById("totalCount");
	var posterFrame = document.getElementById("posterFrame");

	displayInfo("");
	displayMessage("Enter a search term in the <br/> search box above and press RETURN.");
	if(totalCount) totalCount.innerHTML = "";
	if(posterFrame) posterFrame.src = "Images/spacer.png";

	showControl("btnPrev", false);
	showControl("btnNext", false);
	showControl("btnPlay", false);
	showControl("lnkDetails", false);
	showControl("lnkDownload", false);
}

/************************* displayMessage *************************/
function displayMessage(message)
{
	var el = document.getElementById("myScrollArea");
	if(el)
	{
		el.innerHTML = message;
		refreshScrollArea();
	}
}

/************************* displayInfo *************************/
function displayInfo(info)
{
	var el = document.getElementById("info");
	if(el)
	{
		el.innerHTML = info;
	}
}

/************************* refreshScrollArea *************************/
function refreshScrollArea()
{
	if(gMyScrollArea)
	{
		gMyScrollArea.refresh();
	}
}

/************************* displayTotalCount *************************/
function displayTotalCount()
{
	var el = document.getElementById("totalCount");
	if(el)
	{
		var startCount = g_currentPage * CLIPS_PER_PAGE - (CLIPS_PER_PAGE - 1);
		var endCount = g_currentPage * CLIPS_PER_PAGE;
		if(endCount > g_assetCount)
		{
			endCount = g_assetCount;
		}
		el.innerHTML = startCount + " to " + endCount  + " of " + g_assetCount;
	}
}

/************************* getPageCount *************************/
function getPageCount()
{
	if(g_pageCount == 0)
	{
		var pageCount = parseInt(g_assetCount / CLIPS_PER_PAGE);
		var remainder = g_assetCount % CLIPS_PER_PAGE;
		if(remainder > 0)
		{
			pageCount = pageCount + 1;
		}
		g_pageCount = pageCount;
	}

	return g_pageCount;
}

/************************* displayShotDescription *************************/
function displayShotDescription(index)
{
	if(g_loaded)
	{
		if(index == -1)
		{
		}
		else
		{
			// onMouseOver event
			g_hoverIndex = index;
			var thisAsset = g_assetArray[((g_currentPage - 1) * CLIPS_PER_PAGE) + index];
			displayMessage(thisAsset.shotDescription);

		}
	}
}

/************************* displaySelectedShotDescription *************************/
function displaySelectedShotDescription()
{
	if(g_selectedIndex != -1)
	{
		var thisAsset = g_assetArray[g_selectedIndex];
		displayMessage(thisAsset. shotDescription);

	}
		
}

/************************* displayAssets *************************/
function displayAssets()
{
	clearAssets();
	for(i = 0; i < CLIPS_PER_PAGE; i++)
	{
		var img = document.getElementById('img' + i);
		var index = ((g_currentPage - 1) * CLIPS_PER_PAGE) + i;
		if(index <= g_assetArray.length)
		{
			var thisAsset = g_assetArray[index];
			if(thisAsset)
			{
				img.src = thisAsset.posterFrame.src;
			}
		}
	}
}

/************************* clearAssets *************************/
function clearAssets()
{
	for(i = 0; i < CLIPS_PER_PAGE; i++)
	{
		var img = document.getElementById('img' + i);
		if(img)
		{
			img.src = "Images/spacer.png";
		}
	}
}

/************************* activatePosterFrame *************************/
function activatePosterFrame(index)
{
	g_selectedIndex = ((g_currentPage - 1) * CLIPS_PER_PAGE) + index;
	var img = document.getElementById('posterFrame');
	var thisAsset = g_assetArray[((g_currentPage - 1) * CLIPS_PER_PAGE) + index];
	if(thisAsset)
	{
		img.src = thisAsset.posterFrame.src;
		showControl("btnPlay", true);
		showControl("lnkDetails", true);
		showControl("lnkDownload", true);
	}
}

/************************* moveNext *************************/
function moveNext()
{
	if((g_currentPage * CLIPS_PER_PAGE) < g_assetCount)
	{
		g_currentPage = g_currentPage + 1;
		displayAssets();
	}
	
	displayTotalCount();

	if(g_currentPage == getPageCount())
	{
		disableControl("btnNext",  true);
	}

	disableControl("btnPrev",  false);

}

/************************* movePrev *************************/
function movePrev()
{
	if(g_currentPage > 1)
	{
		g_currentPage = g_currentPage - 1;
		displayTotalCount();
		displayAssets();
	}

	if(g_currentPage == 1)
	{
		disableControl("btnPrev",  true);
	}

	disableControl("btnNext", false);
}

/************************* playMovie *************************/
function playMovie(event)
{
	var thisAsset = g_assetArray[g_selectedIndex];
	if(window.widget)
	{
		widget.openApplication("com.apple.quicktimeplayer");
		widget.system("/usr/bin/osascript playQT.scpt " + thisAsset.videoUrl, null);
	}
	else
	{
		qtwin = window.open(thisAsset.videoUrl,"clip","toolbar=0,location=0,directories=0,status=0,menubar=0,scrollbars=0,resizable=1");
		qtwin.focus();
	}
}

/************************* viewDetails *************************/
function viewDetails()
{
	if (widget)
	{
		var thisAsset = g_assetArray[g_selectedIndex];
		url = g_searchDetailsUrl + thisAsset.assetId;
		widget.openURL(url);
	}
}

/************************* downloadClip *************************/
function downloadClip()
{
	if (widget)
	{
		var thisAsset = g_assetArray[g_selectedIndex];
		url = thisAsset.downloadUrl;
		widget.system('/usr/bin/open ' + url, null);
	}
}