function initBtn() {
	new InfoBtn(document.getElementById("infoBtn"),"white");
	createGenericButton(document.getElementById("doneBtn"), getLocalizedString("Done"), function () {
		if (window.widget) widget.prepareForTransition("ToFront");
		document.getElementById("back").style.display="none";
		document.getElementById("front").style.display="block";
		if (window.widget) setTimeout('widget.performTransition();if (onFlipFront) onFlipFront();', 0);
	});
}

var Pref = {
	load : function (aKey, aDef) {
		if (window.widget) {
			var v = widget.preferenceForKey(aKey);
			if (!v) v = aDef;
		} else {
			var v = aDef;
		}
		document.getElementById(aKey).value = v;
	},
	
	save : function (aKey) {
		if (window.widget) {
			widget.setPreferenceForKey(document.getElementById(aKey).value,aKey);
		}
	},
	
	getValue : function (aKey) {
		return document.getElementById(aKey).value;
	}
}

function InfoBtn(aElement,aColor) {
	if (aColor == undefined) aColor = "white";
	this.init(aElement, aColor);
}

InfoBtn.prototype = {
	duration : 500, starttime : 0, now : 0.0, from : 0.0, to : 1.0, timer : null,
	init : function (aElement, aColor) {
		var baseStyle = "display:inline-block;background-repeat:no-repeat;width:13px;height:13px;position:absolute;top:0px;left:0px;";
		var filePath = "file:///System/Library/WidgetResources/ibutton/"+aColor;

		this.flip = document.createElement('span');
		this.flip.setAttribute("style", baseStyle + 'background:url(' + filePath + '_i.png);z-index:8000;opacity:0;');
		aElement.appendChild(this.flip);

		var fliprollie = document.createElement('span');
		fliprollie.setAttribute("style", baseStyle + 'background:url(' + filePath + '_rollie.png);display:none;opacity:0.25;z-index:7999;');
		aElement.appendChild(fliprollie);

		aElement.addEventListener("mouseover", function () {fliprollie.style.display = 'block';}, true);
		aElement.addEventListener("mouseout", function () {fliprollie.style.display = 'none';}, true);
		aElement.addEventListener("mouseup", function () {
			if (onFlipBack) onFlipBack();
			if (window.widget) widget.prepareForTransition("ToBack");
			document.getElementById("front").style.display="none";
			document.getElementById("back").style.display="block";
			if (window.widget) setTimeout('widget.performTransition();', 0);
			fliprollie.style.display = 'none';

		}, true);

		var thisInfoBtn = this;
		var frontPanel = document.getElementById("front");
		frontPanel.addEventListener("mouseover", function () {thisInfoBtn.initAnimate(1.0);}, true);
		frontPanel.addEventListener("mouseout", function () {thisInfoBtn.initAnimate(0.0);}, true);
	},

	initAnimate : function (finalOpacity) {

		with (this) {
			if (timer != null) clearInterval(timer);
			starttime = new Date().getTime();
			timer = setInterval(function () {animate();}, 13);
			from = 	now;	
			to = finalOpacity;
		}
	},

	animate : function () {
		with (this) {
			var t = new Date().getTime() - starttime;
			if (t >= duration) {
				clearInterval(timer);
				timer = null;
				now = to;
			} else {
				now = from + (to-from)*(0.5 - (0.5 * Math.cos(Math.PI * t / duration)));
			}
			flip.style.opacity = now;
		}
	}
}

function getLocalizedString(aKey) {
    try {
		var v = localizedStrings[aKey];
		if ( v != undefined ) return v;
    } catch (ex) {}
    return aKey;
}

function setLabel(aKey) {
	var obj = document.getElementById(aKey);
	obj.innerText = getLocalizedString(aKey);
}


function debug(str) {
	// if (!window.widget) {
		document.getElementById("debug").innerText = str;
	//}
}