var timeoutID = null;
var intervalID = null;
var state_ = "";
var shuffleState = false;

function setup() {
	if (window.widget) {
		widget.onhide = onhide;
		widget.onshow = onshow;
	}

	Pref.load("mutantType", "logo");
	
	setLabel("view");
	
	inputPerfTab("view");
	setMutant(Pref.getValue("mutantType"));
	onshow();
}

function setMutant(mutantType){
	var track = document.getElementById("track");
	var mutant = document.getElementById("mutant");
	var volSlider = document.getElementById("volSlider");
	var volTab = document.getElementById("volTab");
	var timeSlider = document.getElementById("timeSlider");
	var timeTab = document.getElementById("timeTab");
	if (mutantType == "none") {
		mutant.style.display = "none";
	} else {
		track.style.display = "block";
		mutant.style.display = "block";
		volSlider.style.display = "block";
		volTab.style.display = "block";
		mutant.src = "Images/"+mutantType+"/mutant.png";
		volSlider.src = "Images/wolverine/volSlider.png";
		timeSlider.src = "Images/wolverine/timeSlider.png";
		timeTab.src = "Images/wolverine/timeTab.png";
	}
}

function inputPerfTab(aDefault) {
	var  v;
	if (window.widget) {
		v = widget.preferenceForKey("pref_tab");
	}
	if (!v) v = aDefault;
	selectTab(document.getElementById(v));
}

function selectTab(obj) {
	var nodeList=obj.parentNode.getElementsByTagName('li');

	for (var i = 0;i < nodeList.length;i++) {
		if (nodeList[i] == obj) {
			obj.style.textDecoration="underline";
			document.getElementById("pref_"+nodeList[i].id).style.display="block";
		} else {
			nodeList[i].style.textDecoration="none";
			document.getElementById("pref_"+nodeList[i].id).style.display="none";
		}
	}	
	if (window.widget) widget.setPreferenceForKey(obj.id,"pref_tab");
}


function onFlipBack() {
	onhide();
}

function onFlipFront() {
	onshow();
	Pref.save("mutantType");
	setMutant(Pref.getValue("mutantType"));
}

function goSite() {
	if (window.widget) {
		widget.openURL("http://www.x-menthelaststand.com");
	} else {
		location.href = "http://www.x-menthelaststand.com";
	}
}

function updateImg(aImg) {
	if (timeoutID) {
		clearTimeout(timeoutID);
		timeoutID = null;
	}
}

function onhide() {
	if (timeoutID) {
		clearTimeout(timeoutID);
		timeoutID = null;
	}
	if (intervalID) {
		clearInterval(intervalID);
		intervalID = null
	}
}

function onshow() {
	updateMutant();
	intervalID = setInterval("updateMutant();",8000);
}

var isMousemove_ = false;
var statusObj = null;
function updateMutant() {
	if (!window.widget || isMousemove_ || statusObj) return;
	statusObj = widget.system("/usr/bin/osascript Scripts/getStatus.scpt", function () {
		var theResult = statusObj.outputString;
		statusObj = null;
		if (theResult == undefined){
			theResult = "volume:0,duration:0,position:0,title:\"\",status:\"stopped\",kind:\"nomode\"";
		}
		
		var infoObj = eval('return {'+theResult+'}');

		volume_ = infoObj.volume;
		document.getElementById("volTab").style.left = (Math.floor(volume_ / 2) + 207)+"px";
		time_ = Math.floor(infoObj.position/infoObj.duration*128);
		document.getElementById("timeTab").style.left = (time_  + 133)+"px";
		document.getElementById("track").innerText = infoObj.title;
		document.getElementById("mainImg").title = infoObj.title; 
		document.getElementById("timeSlider").style.display = "block";
		document.getElementById("timeTab").style.display = "block";
		
		state_ = infoObj.status;
		playOut(document.getElementById("play"));
	
	});
}

var playpauseObj = null;
function playPause() {
	if (!window.widget || playpauseObj) return;
	playpauseObj = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to playpause'", function () {
		playpauseObj = null;
		updateMutant();
	});
}

function playDown(aObj) {
	if (state_ == "playing") {
		aObj.src = "Images/btn/pause_over.png";
	} else {
		aObj.src = "Images/btn/play_over.png";
	}
}

function playOut(aObj) {
	if (state_ == "playing") {
		aObj.src = "Images/btn/pause.png";
	} else {
		aObj.src = "Images/btn/play.png";
	}
}

var prevnextObj = null;

function doBtn(aObj) {
	if (!window.widget || prevnextObj) return;
	if (aObj.id == "rewind") {
		prevnextObj = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to previous track'", donePN);
	} else {
		prevnextObj = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to next track'", donePN);
	}
}
function donePN() {
	prevnextObj  = null;
	updateMutant();
	btnOut(document.getElementById("rewind"));
	btnOut(document.getElementById("forward"));
}

function btnDown(aObj) {
	aObj.src = "Images/btn/XMen"+aObj.id+".png";
}

function btnOut(aObj) {
	aObj.src = "Images/btn/"+aObj.id+".png";
}

var volume_ = 50;
var volumeObj = null;
function updateVolume() {
	var x = event.clientX - 207;
	var volTab = document.getElementById("volTab");
	if (x < 5) {
		volTab.style.left = "207px";
		x = 0;
	} else if (x > 52) {
		volTab.style.left = (207 + 50)+"px";
		x = 50;
	} else {
		x -= 5; 
		volTab.style.left = (x + 207)+"px";
	}
	volume_ = x * 2;
}

function volDown() {
	isMousemove_ = true;
	document.getElementById("volTab").src = "Images/volTab_on.png";
	document.addEventListener("mousemove", updateVolume, true);
	document.addEventListener("mouseup", volUp, true);
	updateVolume();
}

function volUp() {
	isMousemove_ = false;
	document.getElementById("volTab").src = "Images/volTab.png";
	document.removeEventListener("mousemove", updateVolume, true);
	document.removeEventListener("mouseup", volUp, true);

	if (!window.widget || volumeObj) return;
	volumeObj  = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to set sound volume to "+volume_+"'", function () {volumeObj = null;});
}

var time_ = 0;
var timeObj = null;
function updateTime() {
	var x = event.clientX - 133
	var timeTab = document.getElementById("timeTab");
	if (x < 5) {
		timeTab.style.left = "133px";
		x = 0;
	} else if (x > 130) {
		timeTab.style.left = (133 + 128)+"px";
		x = 128;
	} else {
		x -= 3; 
		timeTab.style.left = (x + 133)+"px";
	}
	time_ = x;
}

function timeDown() {
	isMousemove_ = true;
	document.addEventListener("mousemove", updateTime, true);
	document.addEventListener("mouseup", timeUp, true);
	updateTime();
}

function timeUp() {
	isMousemove_ = false;
	document.removeEventListener("mousemove", updateTime, true);
	document.removeEventListener("mouseup", timeUp, true);

	if (!window.widget || timeObj) return;
	timeObj = widget.system("/usr/bin/osascript -e 'tell app \"iTunes\" to set player position to "+time_+"/128*(duration of current track)'", function () {timeObj = null;});
}